#
# FFS makefile for ABC
#

# If compiling target code with test framework, WITH_TFFS should be 1 and
# tffs.c, tcases.c and tdata.c should be compiled in.

# One of the following flags most be defined: TMFFS1 or TMFFS2. TMFFS1 for the 
# TM3 protocol (PCTM support) or TMFFS2 for the ETM protocol. 

#TISH20040115 Change the ffs_cflags DTMFFS1 to DTMFFS2 by Ellen , for PCTM/ETM
FFS_CFLAGS :=  -mn -mt -mw -o -g -x $(CFLAGSFFS) -DWITH_TFFS=0 -DTMFFS1 -DDRVM_MSFE_SWE 
FFS_RIV_FLAGS := -g -mt -mn $(CFLAGSFFS) -DDRVM_MSFE_SWE

ifneq ($(SRVC), 0)
  FFS_CFLAGS += -DFAX_AND_DATA=FAX_AND_DATA
endif

# Libraries definition
LIB_FFS    := $(OUT_LIB_DIR)/ffs$(NCHP)$(NBRD)$(NGOLITE).lib
LIB_FFSDRV := $(OUT_LIB_DIR)/ffsdrv$(NBRD)$(NGOLITE).lib
LIB_PCM    := $(OUT_LIB_DIR)/pcm$(NSRVC)$(NSTD)$(NDSP)$(NWCP).lib

CFG_LIBS   += $(LIB_FFS) $(LIB_FFSDRV) $(LIB_PCM)

# Source definition
ifdef FFS_SOURCE
SRC_FFS := $(BOARD_DIR)/ffs/core.c\
           $(BOARD_DIR)/ffs/fsck.c\
           $(BOARD_DIR)/ffs/reclaim.c\
           $(BOARD_DIR)/ffs/drv.c\
           $(BOARD_DIR)/ffs/amdsbdrv.c\
           $(BOARD_DIR)/ffs/intelsbdrv.c\
           $(BOARD_DIR)/ffs/ffstrace.c
#           $(BOARD_DIR)/ffs/tffs.c\
#           $(BOARD_DIR)/ffs/tcases.c\
#           $(BOARD_DIR)/ffs/tdata.c

SRC_FFSRIV := $(BOARD_DIR)/ffs/ffs_env.c
endif

SRC_FFSDRV := $(BOARD_DIR)/ffs/cfgffs.c\
              $(BOARD_DIR)/ffs/dev.c\
              $(BOARD_DIR)/ffs/pcmcode.c\
              $(BOARD_DIR)/ffs/tmffs.c\
              $(BOARD_DIR)/ffs/task.c

ifeq ($(BOARD),34)
  SRC_FFSDRV += $(BOARD_DIR)/ffs/ffspcm.c
endif

SRC_PCM := $(BOARD_DIR)/ffs/pcmdata.c


OBJ_FFS    := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_FFS)))
OBJ_FFSRIV := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_FFSRIV)))
OBJ_FFSDRV := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_FFSDRV)))
OBJ_PCM    := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_PCM)))

CFG_OBJS += $(OBJ_FFS) $(OBJ_FFSRIV) $(OBJ_FFSDRV) $(OBJ_PCM)
CFG_DEPS += $(OBJ_FFS:.obj=.d) $(OBJ_FFSRIV:.obj=.d) $(OBJ_FFSDRV:.obj=.d) $(OBJ_PCM:.obj=.d)

ifdef FFS_SOURCE
OBJ_FFS += $(BOARD_DIR)/ffs/target.obj
endif

$(LIB_FFS) : $(OBJ_FFS)
	ar470 r $@ $^

$(LIB_FFSDRV) : $(OBJ_FFSDRV) $(OBJ_FFSRIV)
	ar470 r $@ $^

$(LIB_PCM) : $(OBJ_PCM)
	ar470 r $@ $^

$(OBJ_FFS) $(OBJ_FFSDRV) $(OBJ_PCM) : %.obj: %.c
	cl470 $(FFS_CFLAGS) -fr$(@D) $<

$(OBJ_FFSRIV) : %.obj: %.c
	cl470 $(FFS_RIV_FLAGS) -fr$(@D) $<

$(BOARD_DIR)/ffs/target.c: $(BOARD_DIR)/ffs/ffs.c $(BOARD_DIR)/ffs/mktarget.pl
	perl -w $(BOARD_DIR)/ffs/mktarget.pl
